;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.include "common\global.s"
	.include "common\rnc_2.s"

;////////////////////////////////////////////////////////////////////////////;
;/ constants                                                                /;
;////////////////////////////////////////////////////////////////////////////;
_oam_table == 0xC000
;_Reset == 0x0100

;////////////////////////////////////////////////////////////////////////////;
;/ header patches                                                           /;
;////////////////////////////////////////////////////////////////////////////;
	;.area	_HEADER (ABS)

;////////////////////////////////////////////////////////////////////////////;
;/ absolute ram addresses                                                   /;
;////////////////////////////////////////////////////////////////////////////;
	;.area	_BSS_ABS (ABS)

;////////////////////////////////////////////////////////////////////////////;
;/ variables                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	;.area	_HRAM (ABS)
	;.org	0xFF80

;////////////////////////////////////////////////////////////////////////////;
;/ _RefreshOAM                                                              /;
;////////////////////////////////////////////////////////////////////////////;
_RefreshOAM == 0xFF80

;////////////////////////////////////////////////////////////////////////////;
;/ _main                                                                    /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_main::
	ld		sp, #0xD000
	.globl	_Demo_main
	call	_Demo_main
	di
	jp		0x100

;////////////////////////////////////////////////////////////////////////////;
;/ clear_VBL                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_clear_VBL_LCD::
	.globl	.int_0x40
	ld		hl, #.int_0x40
	ld		d, #32 ;#16
	xor		a, a
1$:
	ld		(hl+), a
	dec		d
	jr		nz, 1$
	ret

;////////////////////////////////////////////////////////////////////////////;
;/ clear_LCD                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

;_clear_LCD::
	;.globl	.int_0x48
	;ld		hl, #.int_0x48
	;ld		d, #16
	;xor		a, a
;1$:
;	ld		(hl+), a
	;dec		d
	;jr		nz, 1$
;	ret

;////////////////////////////////////////////////////////////////////////////;
;/ clear_TIM                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_clear_TIM::
	.globl	.int_0x50
	ld		hl, #.int_0x50
	ld		d, #16
	xor		a, a
1$:
	ld		(hl+), a
	dec		d
	jr		nz, 1$
	ret

;////////////////////////////////////////////////////////////////////////////;
;/ _lcd_FadeOut                                                             /;
;////////////////////////////////////////////////////////////////////////////;
;_lcd_FadeOut::
	;push	bc
	;.globl	lcd_FadeOut
	;call	lcd_FadeOut
	;pop		bc
	;ret

;////////////////////////////////////////////////////////////////////////////;
;/ _Decompress                                                              /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_Decompress::		;void Decompress(void* dest, void* src);
	push	bc
		
	lda		hl, 4(sp)
	ld		a, (hl+)	;dest
	ld		e, a
	ld		a, (hl+)
	ld		d, a
	ld		a, (hl+)	;src
	ld		h, (hl)
	ld		l, a

	.globl	Unpack
	call	Unpack

	pop		bc
	ret

;////////////////////////////////////////////////////////////////////////////;
;/ absolute data                                                            /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_DATA_ABS (ABS)

	.org	0x7E00
_stab::
  .db	0x00,0x03,0x06,0x09,0x0C,0x0F,0x12,0x15,  0x18,0x1B,0x1E,0x21,0x24,0x27,0x2A,0x2D
  .db	0x30,0x33,0x36,0x39,0x3B,0x3E,0x41,0x43,  0x46,0x49,0x4B,0x4E,0x50,0x52,0x55,0x57
  .db	0x59,0x5B,0x5E,0x60,0x62,0x64,0x66,0x67,  0x69,0x6B,0x6C,0x6E,0x70,0x71,0x72,0x74
  .db	0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7B,  0x7C,0x7D,0x7D,0x7E,0x7E,0x7E,0x7E,0x7E
  .db	0x7F,0x7E,0x7E,0x7E,0x7E,0x7E,0x7D,0x7D,  0x7C,0x7B,0x7B,0x7A,0x79,0x78,0x77,0x76
  .db	0x75,0x74,0x72,0x71,0x70,0x6E,0x6C,0x6B,  0x69,0x67,0x66,0x64,0x62,0x60,0x5E,0x5B
  .db	0x59,0x57,0x55,0x52,0x50,0x4E,0x4B,0x49,  0x46,0x43,0x41,0x3E,0x3B,0x39,0x36,0x33
  .db	0x30,0x2D,0x2A,0x27,0x24,0x21,0x1E,0x1B,  0x18,0x15,0x12,0x0F,0x0C,0x09,0x06,0x03
  .db	0x00,0xFD,0xFA,0xF7,0xF4,0xF1,0xEE,0xEB,  0xE8,0xE5,0xE2,0xDF,0xDC,0xD9,0xD6,0xD3
  .db	0xD0,0xCD,0xCA,0xC7,0xC5,0xC2,0xBF,0xBD,  0xBA,0xB7,0xB5,0xB2,0xB0,0xAE,0xAB,0xA9
  .db	0xA7,0xA5,0xA2,0xA0,0x9E,0x9C,0x9A,0x99,  0x97,0x95,0x94,0x92,0x90,0x8F,0x8E,0x8C
  .db	0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x85,  0x84,0x83,0x83,0x82,0x82,0x82,0x82,0x82
  .db	0x81,0x82,0x82,0x82,0x82,0x82,0x83,0x83,  0x84,0x85,0x85,0x86,0x87,0x88,0x89,0x8A
  .db	0x8B,0x8C,0x8E,0x8F,0x90,0x92,0x94,0x95,  0x97,0x99,0x9A,0x9C,0x9E,0xA0,0xA2,0xA5
  .db	0xA7,0xA9,0xAB,0xAE,0xB0,0xB2,0xB5,0xB7,  0xBA,0xBD,0xBF,0xC2,0xC5,0xC7,0xCA,0xCD
  .db	0xD0,0xD3,0xD6,0xD9,0xDC,0xDF,0xE2,0xE5,  0xE8,0xEB,0xEE,0xF1,0xF4,0xF7,0xFA,0xFD

	.org	0x7F00
_ctab::
  .db	0x7F,0x7E,0x7E,0x7E,0x7E,0x7E,0x7D,0x7D,  0x7C,0x7B,0x7B,0x7A,0x79,0x78,0x77,0x76
  .db	0x75,0x74,0x72,0x71,0x70,0x6E,0x6C,0x6B,  0x69,0x67,0x66,0x64,0x62,0x60,0x5E,0x5B
  .db	0x59,0x57,0x55,0x52,0x50,0x4E,0x4B,0x49,  0x46,0x43,0x41,0x3E,0x3B,0x39,0x36,0x33
  .db	0x30,0x2D,0x2A,0x27,0x24,0x21,0x1E,0x1B,  0x18,0x15,0x12,0x0F,0x0C,0x09,0x06,0x03
  .db	0x00,0xFD,0xFA,0xF7,0xF4,0xF1,0xEE,0xEB,  0xE8,0xE5,0xE2,0xDF,0xDC,0xD9,0xD6,0xD3
  .db	0xD0,0xCD,0xCA,0xC7,0xC5,0xC2,0xBF,0xBD,  0xBA,0xB7,0xB5,0xB2,0xB0,0xAE,0xAB,0xA9
  .db	0xA7,0xA5,0xA2,0xA0,0x9E,0x9C,0x9A,0x99,  0x97,0x95,0x94,0x92,0x90,0x8F,0x8E,0x8C
  .db	0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x85,  0x84,0x83,0x83,0x82,0x82,0x82,0x82,0x82
  .db	0x81,0x82,0x82,0x82,0x82,0x82,0x83,0x83,  0x84,0x85,0x85,0x86,0x87,0x88,0x89,0x8A
  .db	0x8B,0x8C,0x8E,0x8F,0x90,0x92,0x94,0x95,  0x97,0x99,0x9A,0x9C,0x9E,0xA0,0xA2,0xA5
  .db	0xA7,0xA9,0xAB,0xAE,0xB0,0xB2,0xB5,0xB7,  0xBA,0xBD,0xBF,0xC2,0xC5,0xC7,0xCA,0xCD
  .db	0xD0,0xD3,0xD6,0xD9,0xDC,0xDF,0xE2,0xE5,  0xE8,0xEB,0xEE,0xF1,0xF4,0xF7,0xFA,0xFD
  .db	0x00,0x03,0x06,0x09,0x0C,0x0F,0x12,0x15,  0x18,0x1B,0x1E,0x21,0x24,0x27,0x2A,0x2D
  .db	0x30,0x33,0x36,0x39,0x3B,0x3E,0x41,0x43,  0x46,0x49,0x4B,0x4E,0x50,0x52,0x55,0x57
  .db	0x59,0x5B,0x5E,0x60,0x62,0x64,0x66,0x67,  0x69,0x6B,0x6C,0x6E,0x70,0x71,0x72,0x74
  .db	0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7B,  0x7C,0x7D,0x7D,0x7E,0x7E,0x7E,0x7E,0x7E
