//////////////////////////////////////////////////////////////////////////////
// main.c                                                                   //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include "common.h"
#include "LP1.297a.c"

#define DIV 7

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
int nbr_patern = 24;

extern u8 mymusic0[];
extern u8 mymusic1[];
extern u8 mymusic2[];
extern u8 mymusic3[];
//extern u8 mymusic4[];

const u8 patterns[] =
{
	1,2,3,4,5,6,7,8,13,14,16,15,
	9,10,11,12,17,18,19,20,21,22,23,24
	
	/*0,1,4,2,3,4,5,6,7,8,9,10,
	11,12,11,12,13,14,15,16,17,18,11,12,
	11,12,13,14,15,16,17,19,20,21,22,23,
	23,24,25,26,27,28,25,26,27,28,29,30,
	31,32,*/
	
	//1
	//7,0,1,0,1,2,3,4,5,4,8,6,9,10,12,10,11,13,4,8,4,5,6,9,6,9,10,12,10,11,
	
	//hurry scurry 38-1;
	//3,4,5,6,7,0,1,0,2,10,13,11,12,8,9,8,9,0,1,0,1,10,13,11,12,8,9,8,9,0,1,0,1, 0, 1, 0,1,14,
};

//////////////////////////////////////////////////////////////////////////////
// patern_definition                                                        //
//////////////////////////////////////////////////////////////////////////////
void patern_definition()
{
	// pattern is 512 bytes, svbk bank is 4096 bytes
	u8 p = patterns[patern];
	SVBK_REG = 2 + (p>>3);
	data_song_ptr = (u16*) ( 0xD000 | (u16)(p&7)<<9 );
}

//////////////////////////////////////////////////////////////////////////////
// TIM_irq                                                                  //
//////////////////////////////////////////////////////////////////////////////
static void TIM_irq()
{
	set_interrupts(LCD_IFLAG | TIM_IFLAG);	// no big irq's
	//enable_interrupts();
	if (clock01 == 0)
	{
		patern_definition();
		music();
		sync_flip^=1;
	}
	if (++clock01 >= DIV) clock01=0;		// set the speed of your music
	SVBK_REG = 1;
	set_interrupts(VBL_IFLAG | LCD_IFLAG | TIM_IFLAG);
}

//////////////////////////////////////////////////////////////////////////////
// Lemon_main                                                               //
//////////////////////////////////////////////////////////////////////////////
void Lemon_main()
{
	u8 i;
	
	clear_TIM();
	clock01=0;
	step=0;
	patern=0;
	stopmusic();
	//patern_definition();
	
	SVBK_REG = 2; Decompress((u8*)0xD000, mymusic0);
	SVBK_REG = 3; Decompress((u8*)0xD000, mymusic1);
	SVBK_REG = 4; Decompress((u8*)0xD000, mymusic2);
	SVBK_REG = 5; Decompress((u8*)0xD000, mymusic3);
//	SVBK_REG = 6; Decompress((u8*)0xD000, mymusic4);
	
	
	TMA_REG = 256-128;	// 4096/256 = 16 KHz
	TAC_REG = 4;		// 4096 KHz
	add_TIM(TIM_irq);
}

//////////////////////////////////////////////////////////////////////////////
// Lemon_Stop                                                               //
//////////////////////////////////////////////////////////////////////////////
void Lemon_Stop()
{
	clear_TIM();
	resetmusic();
}
