;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.include "common\global.s"

;////////////////////////////////////////////////////////////////////////////;
;/ absolute ram addresses                                                   /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_BSS_ABS (ABS)

_Do2_dest	== 0xC400	;SMC destination
_Do2_dest2	== _Do2_dest

	.org	0xC000
_oam1b::
	.ds		160

	.org	0xC600
_oam2b::
	.ds		160

	.org	0xC700
_scx::
	.ds	80				;sin/cos * x

	.org	0xC800		;11001000
_tilemap::				;tilemap to be DMA'ed
	.ds 18*32

	.org	0xCC00		;11001100. SEE "to attrmap"
_attrmap::				;attrmap to be DMA'ed
	.ds 18*32

	.org	0xD000
_bitmap_ram::
	.ds 64*64

;////////////////////////////////////////////////////////////////////////////;
;/ variables                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_HRAM (ABS)
	.org	0xFFC0
.sp_reg:	.ds 2		;backup of stack pointer
_s::		.ds 2
_c::		.ds 2
_s_ox::		.ds 2
_c_ox::		.ds 2
_s_oy::		.ds 2
_c_oy::		.ds 2
_mp::		.ds 2		;map pointer

;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

;_LoadRotoBitmap::		;64x64 bitmap to 0xD000
;	push	bc
	
	;lda		hl, 4(sp)	;get pointer
	;ld		a, (hl+)
	;ld		d, (hl)
	;ld		e, a
;
	;ld		hl, #0xD000	;bitmap in SVBK 1
	;ld		a, #1
	;ldh		(.SVBK), a

1$:
	;push	bc
	
	;load line of tile in bc
	;ld		a, (de)		;l
	;inc		de
	;ld		c, a
	;ld		a, (de)		;h
	;inc		de
	;ld		b, a

	;pixel
	;xor		a, a
	;srl		b
	;rla
	;srl		a
	;rla
	;ld		(hl+), a
	
	;pixel
	;xor		a, a
	;srl		b
	;rla
	;srl		a
	;rla
	;ld		(hl+), a

	;pixel
	;xor		a, a
	;srl		b
	;rla
	;srl		a
	;rla
	;ld		(hl+), a

	;pixel
	;xor		a, a
	;srl		b
	;rla
	;srl		a
	;rla
	;ld		(hl+), a



	
	;pop		bc
	;ret

;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_RotoTiles::
	push	bc

	ld		hl, #0x8800
	ld		d, #>.tiledivs
	ld		c, #0
1$:

	ld		a, c		;Tttttttt
	xor		a, #0x80
	swap	a			;ttttTttt
	and		a, #0x0F	;0000Tttt
	sla		a			;000Tttt0
	add		a, #0xE0	;111Tttt0
	ld		e, a		;111Tttt0
	ld		a, (de)
	ld		b, a
	inc		e
	ld		a, (de)
	ld		e, a

	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a
	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a
	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a
	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a

	ld		a, c		;Tttttttt
	xor		a, #0x80
	and		a, #0x0F	;0000tttt
	sla		a			;000tttt0
	add		a, #0xE0	;111Tttt0
	ld		e, a		;111Tttt0
	ld		a, (de)
	ld		b, a
	inc		e
	ld		a, (de)
	ld		e, a

	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a
	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a
	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a
	ld		a, b
	ld		(hl+), a
	ld		a, e
	ld		(hl+), a

	inc		c
	jr		nz, 1$

	pop		bc
	ret

;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_SetRot::
	push	bc

	ld		de, #_scx	;pscx1 = scx
	ld		c, #40
1$:

		;s_ox += s; *pscx1++ = *s_oxH;
	ld		hl, #_s_ox
	ldh		a, (_s)
	add		a, (hl)
	ld		(hl+), a
	ldh		a, (_s+1)
	adc		a, (hl)
	ld		(hl), a
	
	ld		(de), a
	inc		e

		;c_ox -= c; *pscx1++ = *c_oxH;
	ld		hl, #_c_ox
	ld		a, (_c)
	add		a, (hl)
	ld		(hl+), a
	ld		a, (_c+1)
	adc		a, (hl)
	ld		(hl), a
	ld		(de), a
	inc		e

	dec		c
	jr		nz, 1$
	
	pop		bc
	ret

;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_Do2::						;relocated to _Do2_dest !!!
	;standard push
	push	bc


	ld		c, #18
.row_loop:
	push	bc



	;calc s*y for top/bottom half of tiles and modify code	
	ld		hl, #_s_oy
		;s_oy+=s; sy1 = *s_oyH;
	ldh		a, (_s)
	add		a, (hl)
	ld		(hl+), a
	ldh		a, (_s+1)
	adc		a, (hl)
	ld		(hl-), a
	ld		(.sy1_1+1 + _Do2_dest-_Do2), a
	ld		(.sy1_2+1 + _Do2_dest-_Do2), a	
		;s_oy+=s; sy2 = *s_oyH;
	ldh		a, (_s)
	add		a, (hl)
	ld		(hl+), a
	ldh		a, (_s+1)
	adc		a, (hl)
	ld		(hl), a	
	ld		(.sy2_1+1 + _Do2_dest-_Do2), a
	ld		(.sy2_2+1 + _Do2_dest-_Do2), a
	
	;calc c*y for top/bottom half of tiles and modify code	
	ld		hl, #_c_oy
		;c_oy+=c; cy1 = *c_oyH;	
	ld		a, (_c)
	add		a, (hl)
	ld		(hl+), a
	ld		a, (_c+1)
	adc		a, (hl)
	ld		(hl-), a
	ld		(.cy1_1+1 + _Do2_dest-_Do2), a
	ld		(.cy1_2+1 + _Do2_dest-_Do2), a
		;c_oy+=c; cy2 = *c_oyH;	
	ld		a, (_c)
	add		a, (hl)
	ld		(hl+), a	
	ld		a, (_c+1)
	adc		a, (hl)
	ld		(hl), a
	ld		(.cy2_1+1 + _Do2_dest-_Do2), a
	ld		(.cy2_2+1 + _Do2_dest-_Do2), a

;////////////////////////////////////////////////////////////////////////////;

	;save/init sp
	di
	ld		(.sp_reg), sp
	ld		sp, #_scx

	;col loop
	ld		c, #20
.col_loop:

;////////////////////////////////////////////////////////////////////////////;

	pop		de		;d=cx, e=sx

.sy1_1:
	ld		a, #9	;a = sy
	add		a, d	;a += cx
	ld		l, a	;........ Xxxxxxxx

.cy1_1:
	ld		a, #9	;a = cy
	add		a, e	;a += sx

						;Yyyyyyyy ? Xxxxxxxx
	rra					;?Yyyyyyy y Xxxxxxxx
	rra					;y?Yyyyyy y Xxxxxxxx
	rra					;yy?Yyyyy y Xxxxxxxx
	rr		l			;yy?Yyyyy x yXxxxxxx
	rra					;xyy?Yyyy y yXxxxxxx
	rr		l			;xyy?Yyyy x yyXxxxxx
	and		a, #0x0F	;0000Yyyy ? yyXxxxxx
	add		a, #0xD0	;1011Yyyy ? yyXxxxxx
	ld		h, a


	ld		a, (hl)
	rrca			;bit 0 -> cf
	rl		b		;cf -> b
	rrca			;bit 1 -> cf
	rl		b		;cf -> b

;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;

	pop		de		;d=cx, e=sx

.sy1_2:
	ld		a, #9	;a = sy
	add		a, d	;a += cx
	ld		l, a	;........ Xxxxxxxx

.cy1_2:
	ld		a, #9	;a = cy
	add		a, e	;a += sx

						;Yyyyyyyy ? Xxxxxxxx
	rra					;?Yyyyyyy y Xxxxxxxx
	rra					;y?Yyyyyy y Xxxxxxxx
	rra					;yy?Yyyyy y Xxxxxxxx
	rr		l			;yy?Yyyyy x yXxxxxxx
	rra					;xyy?Yyyy y yXxxxxxx
	rr		l			;xyy?Yyyy x yyXxxxxx
	and		a, #0x0F	;0000Yyyy ? yyXxxxxx
	add		a, #0xD0	;1011Yyyy ? yyXxxxxx
	ld		h, a


	ld		a, (hl)
	rrca			;bit 0 -> cf
	rl		b		;cf -> b
	rrca			;bit 1 -> cf
	rl		b		;cf -> b

;////////////////////////////////////////////////////////////////////////////;
	add		sp, #-4	;repeat for bottom half tile
;////////////////////////////////////////////////////////////////////////////;

	pop		de		;d=cx, e=sx

.sy2_1:
	ld		a, #9	;a = sy
	add		a, d	;a += cx
	ld		l, a	;........ Xxxxxxxx

.cy2_1:
	ld		a, #9	;a = cy
	add		a, e	;a += sx

						;Yyyyyyyy ? Xxxxxxxx
	rra					;?Yyyyyyy y Xxxxxxxx
	rra					;y?Yyyyyy y Xxxxxxxx
	rra					;yy?Yyyyy y Xxxxxxxx
	rr		l			;yy?Yyyyy x yXxxxxxx
	rra					;xyy?Yyyy y yXxxxxxx
	rr		l			;xyy?Yyyy x yyXxxxxx
	and		a, #0x0F	;0000Yyyy ? yyXxxxxx
	add		a, #0xD0	;1011Yyyy ? yyXxxxxx
	ld		h, a


	ld		a, (hl)
	rrca			;bit 0 -> cf
	rl		b		;cf -> b
	rrca			;bit 1 -> cf
	rl		b		;cf -> b

;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;

	pop		de		;d=cx, e=sx

.sy2_2:
	ld		a, #9	;a = sy
	add		a, d	;a += cx
	ld		l, a	;........ Xxxxxxxx

.cy2_2:
	ld		a, #9	;a = cy
	add		a, e	;a += sx

						;Yyyyyyyy ? Xxxxxxxx
	rra					;?Yyyyyyy y Xxxxxxxx
	rra					;y?Yyyyyy y Xxxxxxxx
	rra					;yy?Yyyyy y Xxxxxxxx
	rr		l			;yy?Yyyyy x yXxxxxxx
	rra					;xyy?Yyyy y yXxxxxxx
	rr		l			;xyy?Yyyy x yyXxxxxx
	and		a, #0x0F	;0000Yyyy ? yyXxxxxx
	add		a, #0xD0	;1011Yyyy ? yyXxxxxx
	ld		h, a

	ld		a, (hl)
	rrca			;bit 0 -> cf
	rl		b		;cf -> b
	rrca			;bit 1 -> cf
	rl		b		;cf -> b

;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;

	;attr (1 of 4)
	;ld		a, b
	and		a, #7
	ld		e, a

	;tile
	ldh		a, (_mp+0)		;a = low byte
	ld		l, a
	inc		a				;increase
	ldh		(_mp+0), a
	ldh		a, (_mp+1)
	ld		h, a
	ld		(hl), b			;save tile
	set		2, h			;to attrmap
	ld		(hl), e			;save attr

	;col loop
	dec		c
	jp		nz, .col_loop + _Do2_dest-_Do2

	;restore sp
	ldh		a, (.sp_reg+0)
	ld		l, a
	ldh		a, (.sp_reg+1)
	ld		h, a
	ld		sp, hl
	ei

	;skip non-visible area
	ldh		a, (_mp+0)		;a = low byte
	add		a, #32-20
	ldh		(_mp+0), a
	jr		nc, 8$
	ldh		a, (_mp+1)		;a = high byte
	inc		a
	ldh		(_mp+1), a
8$:

	;row loop
	pop		bc
	dec		c
	jp		nz, .row_loop + _Do2_dest-_Do2

	;standard pop/return
	pop		bc
	ret

_Do2_end::

;////////////////////////////////////////////////////////////////////////////;
;/ absolute data                                                            /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_DATA_ABS (ABS)

	.org	0x7DE0	;[16][2]
.tiledivs::
  .db	0x00,0x00, 0x0F,0x00, 0x00,0x0F, 0x0F,0x0F
  .db	0xF0,0x00, 0xFF,0x00, 0xF0,0x0F, 0xFF,0x0F
  .db	0x00,0xF0, 0x0F,0xF0, 0x00,0xFF, 0x0F,0xFF
  .db	0xF0,0xF0, 0xFF,0xF0, 0xF0,0xFF, 0xFF,0xFF
